Rollout heightmapsRoll "Heightmap Terrain"
(
	local mapSize

	Group "Slow but accurate"
	(
		checkbox lab "Progress Bar"
		label laf "Enter positive numbers"
		edittext OutRestx "OuputRes:"
		edittext LandSizetx "LandSize:"
		label estText "ETA:    mins"
		button genButton "Generate"
	)

	on OutRestx changed fred do
	(
		if ((fred as integer) > 0) do
		(
			freddy = (fred as integer)

			eta = ((freddy*freddy*0.0025) as float)
			if eta < 60 then
			(
				estText.text = (eta as string) + " secs"
			)
			else
			(
				estText.text = ((eta/60) as string) + " Mins"
			)
		)
	)

	on genButton pressed do
	(	
		fname = getSaveFileName caption: "RAW 16bit" types:".raw|*.raw|"
		if fname != undefined then
		(
			a = #()
			s = $
			
			lowestpoint = s.min.z
				-- texture pixels
			mapSize = (OutRestx.text as integer)
			mapmod = ((100.0/(mapSize as float)) as float)
				 -- each px represents this squaremeters
			incrementa = (LandSizetx.text as float)/(mapSize as float)
			mapOffset = (0.5*incrementa)

			nScale = (65536.0 as float)/(-lowestpoint)
			progressStart "Generating Heightmap"
			progressUpdate 0
			f=fopen fname "wb"
			start = timeStamp()
			if lab.checked then
			(
				for n = 1 to mapSize do
				(
					for i = 1 to mapSize do 
					(
						arr = (intersectRay s (ray [(incrementa*i-mapOffset),(incrementa*n-mapOffset),10] [0,0,-1]))
						if arr == undefined then WriteShort f 0
						else WriteShort f ((arr.pos.z - lowestpoint)*nScale)
					)
				if getProgressCancel() do
				(
					fclose f
					progressEnd()
					print "USER TERMINATED PROCESS"
					exit
				)
				progressUpdate (n*mapmod)
				)
			)
			else
			(
				for n = 1 to mapSize do
				(
					for i = 1 to mapSize do 
					(
						arr = (intersectRay s (ray [(incrementa*i-mapOffset),(incrementa*n-mapOffset),0.1] [0,0,-0.1]))
						if arr == undefined then WriteShort f 0
						else WriteShort f ((arr.pos.z - lowestpoint)*nScale)
					)			
				)
			)
			fclose f
			progressEnd()
			ending = timeStamp()
			print ""
			format "\nProcessing took % seconds\nResolution: %x%\n-------\nNumber of samples: %\nPolygons: %\nSamples Per second: %\n" ((ending - start) / 1000.0) mapSize mapSize (mapSize*mapSize) $.numfaces ( (mapSize*mapSize) / ((ending - start) / 1000.0) )
			print ""




		)
	)

)
