Bfsm_projectName = undefined
obj_high = undefined 
obj_low = undefined
obj_low2 = undefined

Rollout exportBFRoll "Export .sm"
(
	Group "Mesh selection"
	(
		pickbutton choosehi "Main Visible Mesh" 
		pickbutton chooselo "Collision 1"
		pickbutton chooselo2 "Collision 2" enabled:false
	)
	Group "Save"
	(
		radiobuttons sm_header labels:#("Std (09)", "Lightmap (0A)")
		spinner lodnum "Level of detail meshes: " range:[1,6,1] type:#integer fieldWidth:32
		button exportButton "Export Mesh" enabled:false
		checkbox rsOption1 "Simple Shaders" checked:true
		checkbox options1 "Automated Save" checked:false
		checkbox matIDoption "MatID overide enable" checked:true
		spinner matIDuse "MatID overide value: " range:[0,255,61] type:#integer fieldWidth:32
		button rstBFsm "Defaults"
	)

fn setMydefaults none =
(
	sm_header.state = 1
	lodnum.range = [1,6,1]
	Bfsm_projectName = undefined
	obj_high = undefined
	obj_low = undefined
	obj_low2 = undefined
	exportButton.enabled = false
	rsOption1.checked = true
	options1.checked = false
	matIDoption.checked = true
	choosehi.text =  "Main Visible Mesh" 
	chooselo.text =  "Collision 1"
	chooselo2.text =  "Collision 2"
	chooselo2.enabled =  false
)
		on rstBFsm pressed do setMydefaults 1
		on sm_header changed sm_header2 do headerVersion = sm_header2

		on choosehi picked obj do 
		(  
			obj_high = obj
			Bfsm_projectName = obj_high.name
			choosehi.text = "MainMesh: " + obj.name
			exportButton.enabled=true
		) 	
		
		on chooselo picked obj do 
		(  
			obj_low = obj
			chooselo.text = "Col: " + obj.name
			chooselo2.enabled = true
		)

		on chooselo2 picked obj do 
		(  
			obj_low2 = obj
			chooselo2.text = "Col2: " + obj.name
		) 

		on exportButton pressed do
		(
			if obj_high == undefined then
			(
				messageBox "You must first select your visible high-res object mesh"
			)
			else
			(
				Bfsm_projectName = obj_high.name

				if options1.checked do
				(
					print "feature to write supporting .con files"
				)

---------------------------
-----//START EXPORT sm
---------------------------
				if options1.checked then
				(
					fname = (projectPath + "standardMesh\\"+Bfsm_projectName + ".sm")
					print ("Saved file as: " + fname)
				)
				else
				(
					fname = getSaveFileName caption:"Export .sm" types:"Standard Mesh .sm|*.sm|All|*.*|"
				)

				if fname != undefined then
				(
					print "I will be exporting your meshes for you today.\nI'll take it from here..."
					print "Exporting... "
					numCollisionM = 0
					testing = obj_high -- prevents fatal crash
					if obj_low != undefined do numCollisionM+=1
					if obj_low2 != undefined do numCollisionM+=1

						bboxA = ((geometry[1].min)*SMscale)
						bboxB = ((geometry[1].max)*SMscale)
						
						f=fopen fname "wb"
						progressStart "Exporting .sm"
							-- header
						WriteLong f (8+headerVersion)
						WriteLong f 0
							-- bounding box
						writefloat f bboxA.x  -- x start
						writefloat f bboxA.z  -- z  altitude
						writefloat f bboxA.y  -- y
						writefloat f bboxB.x  -- x ending
						writefloat f bboxB.z  -- z  altitude
						writefloat f bboxB.y  -- y
							
						if headerVersion==2 do
						(
							WriteByte f 1
						)

						writelong f numCollisionM				

	----//smExport COLLISION
						if numCollisionM != 0 do
						(
							for b=1 to numCollisionM do
							(
								if b == 1 then currentMesh = obj_low
								else currentMesh = obj_low2

								convertTo currentMesh TriMeshGeometry

								print ("Working on this mesh: "+(currentMesh.name as string))
								numVerts = currentMesh.numVerts
								numFaces = currentMesh.numFaces
							
								bytesInGroup = (28+(numVerts)*16+(numFaces)*44+30)
								
								WriteLong f bytesInGroup

									-- header
									WriteByte f 250
									WriteByte f 194
									WriteByte f 151
									WriteByte f 235
									WriteLong f 5

								WriteLong f numVerts
								for i=1 to numVerts do
								(
									WriteFloat f ((currentMesh.verts[i].pos.x)*SMscale)
									WriteFloat f ((currentMesh.verts[i].pos.z)*SMscale)
									WriteFloat f ((currentMesh.verts[i].pos.y)*SMscale)
									
									WriteFloat f ((currentMesh.verts[i].pos.x)*SMscale)
										-- Seek back and optimize floating point bits
									fseek f -4 #seek_cur
									if matIDoption.checked then
									(
										WriteShort f matIDuse.value
									)
									else
									(
										WriteShort f (getFaceMatID currentMesh 1)
									)
									fseek f 2 #seek_cur
								)
								WriteLong f numFaces

								for i=1 to numFaces do
								(
									WriteShort f ((getface currentMesh i).x - 1)
									WriteShort f ((getface currentMesh i).y - 1)
									WriteShort f ((getface currentMesh i).z - 1)

									if matIDoption.checked then
									(
										WriteShort f matIDuse.value
									)
									else
									(
										WriteShort f (getFaceMatID currentMesh i)
									)
								)

				
								WriteLong f numFaces --has to do with faces? unknown
								Writelong f 0 -- Unknown2

								 -- verts again
								WriteLong f numFaces

								for i=1 to numFaces do
								(
									WriteFloat f ((getFaceNormal currentMesh i).x)
									WriteFloat f ((getFaceNormal currentMesh i).z)
									WriteFloat f ((getFaceNormal currentMesh i).y)

									WriteLong f 0 -- unknown but seems to be 0 always
									WriteLong f ((getface currentMesh i).x - 1)
									WriteLong f ((getface currentMesh i).y - 1)
									WriteLong f ((getface currentMesh i).z - 1)
								
									if matIDoption.checked then
									(
										WriteLong f matIDuse.value
									)
									else
									(
										WriteLong f (getFaceMatID currentMesh i)
									)
								)
								
								WriteString f "File written by Rexman "
								WriteLong f numFaces

								for i=0 to (numFaces - 1) do
								(
									WriteLong f i #unsigned
								)

								WriteShort f 0 -- just filler
							)			
						)
	
				--Start material stuff
				saveMaxFile (tmpDir+"temporary.max") -- work from a copy

				-- GET RID OF COLLISION MODELS HERE
				if obj_low != undefined do
				(
					if obj_low != obj_high do delete obj_low
					if obj_low2 != undefined do
					(
						if obj_low2 != obj_high do delete obj_low2
					)
				)

				nSceneMatMeshes = geometry.count
				numLODM = lodnum.value

				if options1.checked do
				(
					Print "automated .RS export"
					fname = (projectPath + "standardMesh\\"+Bfsm_projectName + ".rs")
					print ("Saved rs file as: " + fname)
					frs = createFile fname
					if frs != undefined then
					(
						for i=1 to nSceneMatMeshes do
						(
							clearSelection()
							tmpmat = geometry[i].material

							-- next part checks to make sure 1 material
							try	tmpmat.count
							catch results = true
							if results == true do
							(	
								try	tmpmat.specularlevel
								catch resulta = false
								if resulta != false do
								(
								
									if (tmpmat.specularlevel > 0.0) then
									lightspec = true							
									else lightspec = false
									one255 = 1.0/255.0								

									format "subshader \"%_Material%\" \"StandardMesh/Default\"\n{\n" Bfsm_projectName (i-1) to:frs
									format "\tlighting %;\n" "true" to:frs								

									if rsOption1.checked == false then
									(
										format "\tmaterialDiffuse % % %;\n" (tmpmat.diffuse.r*one255) (tmpmat.diffuse.g*one255) (tmpmat.diffuse.b*one255) to:frs
										format "\tlightingSpecular %;\n" lightspec to:frs
										if lightspec do
										(
											format "\tmaterialSpecular % % %;\n" (tmpmat.specular.r*one255) (tmpmat.specular.g*one255) (tmpmat.specular.b*one255) to:frs
											format "\tmaterialSpecularPower %;\n" tmpmat.specularlevel to:frs
										)
										if tmpmat.twosided do
										format "\ttwosided true;\n" to:frs
										if tmpmat.opacity < 100.0 do
										format "\ttransparency true;\n" to:frs
										if tmpmat.faceted do
										format "\tenvmap true;\n" to:frs

									)
									else
									(
										format "\tmaterialDiffuse % % %;\n" 1 1 1 to:frs
										format "\tlightingSpecular %;\n" "false" to:frs
									)

									try
									tmpFname = (getFilenameFile tmpmat.maps[2].bitmap.filename)
									catch resultz = false
									if resultz == false then
									format "\ttexture \"texture/notexture\";\n" to:frs
									else
									format "\ttexture \"texture/%\";\n" (getFilenameFile tmpmat.maps[2].bitmap.filename) to:frs	
									
									format "}\n" to:frs
								)
							)
						)
						close frs
					)
					else print ".rs save failed"
				)

				MeshName = #()
				for i=1 to nSceneMatMeshes do
				(
					MeshName[i] = geometry[i].name
					geometry[i].name = ((i+9) as string) -- starts with 10
				)
				if numLODM > 1 do
				(
					Stepping = (1.0/numLODM as float)
					select obj_high
					macros.run "Modifier Stack" "Convert_to_Mesh"
					-- print ("Stepping: "+(Stepping as string)) --debug
					for i=1 to nSceneMatMeshes do
					(
						for y = 1 to numLODM do
						(
							thisguy = (copy geometry[i]) -- make a copy to work from
							thisguy.name = (((i+9) as string)+"_"+(y as string))
							-- convertTo thisguy TriMeshGeometry
							addModifier thisguy (MultiRes())
							tmpMod = (100.0*(1-y*stepping+stepping*0.5) as float)
							-- print ((y as string)+"_tmpMod: "+(tmpMod as string)) --debug
							thisguy.modifiers[#MultiRes].Vertex_Percentage = tmpMod
							thisguy.modifiers[#MultiRes].generate = true
						)
					)
				)

				exportFile (tmpDir+"tmp3ds.3ds") #noPrompt

				resetMAXFile #noPrompt

				ImportFile (tmpDir+"tmp3ds.3ds") #noPrompt
				for i=1 to nSceneMatMeshes do
				(
					geometry[i].name = MeshName[i]
				)
				
						print ("Lod meshes: "+(numLODM as string))
						writelong f numLODM  	--// # lod model groups

						for g = 1 to numLODM do
						(						
							writelong f nSceneMatMeshes 	--// materials in this lod model

							for h = 1 to nSceneMatMeshes do
							(
								if g > 1 then
								(
									if h == 1 then
									(
										-- intentional skip of first generated Lod mesh
										-- subtract 1 to use the first and skip the last
										indexa = (nSceneMatMeshes+g-1)
									)
									else
									(
										indexa = (nSceneMatMeshes+(h-1)*numLODM+g)			
									)
									currentMesh = geometry[indexa]
								)
								else
								(
									currentMesh = geometry[h]
								)
							

								print ("Working on this mesh: "+(currentMesh.name as string))
								numbaTverts = getNumtverts currentMesh
								numbaVerts = getnumverts currentMesh

									-- materail name lenght
								WriteLong f ( (Bfsm_projectName+"_Material"+((h-1) as string)).count ) 
									-- material name
								WriteString f  (Bfsm_projectName+"_Material"+((h-1) as string) )  

									-- begin unknown data //header?
									WriteByte f 0
									WriteByte f 0
									WriteByte f 0
									WriteLong f 0
									WriteLong f 0
									WriteLong f 4
									WriteLong f 1041
									WriteLong f 32
									-- end unknown data
									
								WriteLong f numbaverts -- could also be changed to tverts
								WriteLong f (currentMesh.numfaces*3)
								WriteLong f 0	-- unknown 0,1,2
							)

							for h = 1 to nSceneMatMeshes do
							(
								if g > 1 then
								(
									if h == 1 then
									(
										-- intentional skip of first generated Lod mesh
										-- subtract 1 to use the first and skip the last
										indexa = (nSceneMatMeshes+g-1)
									)
									else
									(
										indexa = (nSceneMatMeshes+(h-1)*numLODM+g)			
									)
									currentMesh = geometry[indexa]
								)
								else
								(
									currentMesh = geometry[h]
								)
								
								numbaTverts = getNumtverts currentMesh
								numbaVerts = getnumverts currentMesh

								--// tverts have to = nverts is unoptimzed but that is just how it is

								for i = 1 to (numbaverts) do
								(
									WriteFloat f ((currentMesh.verts[i].pos.x)*SMscale)
									WriteFloat f ((currentMesh.verts[i].pos.z)*SMscale)
									WriteFloat f ((currentMesh.verts[i].pos.y)*SMscale)
									
									-- vertex normals
									WriteFloat f (getNormal currentMesh i).x
									WriteFloat f (getNormal currentMesh i).z
									WriteFloat f (getNormal currentMesh i).y
									
									if i <= numbaTverts then
									(
										WriteFloat f (gettvert currentMesh i).x
										WriteFloat f -(gettvert currentMesh i).y
									)
									else
									(
										-- garbage Texture coordinates, prevents crash
										WriteFloat f 0.5 
										WriteFloat f -0.5
									)

								)
			

									-- face data
									for i = 1 to (currentMesh.numfaces) do
									(
										WriteShort f ((getface currentMesh i).x - 1)
										WriteShort f ((getface currentMesh i).y - 1)
										WriteShort f ((getface currentMesh i).z - 1)
										
									)

							)
						)
			
						-- footer
						WriteLong f 0
						WriteLong f 54
						WriteByte f 252 #unsigned
						WriteByte f 194 #unsigned
						WriteByte f 195 #unsigned
						WriteByte f 153 #unsigned
						WriteLong f 3
						WriteLong f 0
						WriteLong f 0
						WriteLong f 0
						WriteLong f 0
						WriteLong f 538976288
						WriteLong f 540024864
						WriteLong f 1717987684 #unsigned
						WriteLong f 174420853
						WriteLong f 544761202
						WriteLong f 540024864
						WriteLong f 0
						WriteShort f 0
							
						fclose f -- closes the file
						progressEnd()
						print "..Successful Export"
				)
			)
		----//END EXPORT
	)
)